use anyhow::Result;
use clap::Clap;
use std::{
    fs::File,
    io::{BufRead, BufReader},
};

/// Print a list of existing message queues
#[derive(Clap, Debug)]
pub struct List {}

impl List {
    pub fn run(&self) -> Result<()> {
        let file = BufReader::new(File::open("/proc/sysvipc/msg")?);

        for line in file.lines() {
            for field in line?.split_whitespace().collect::<Vec<&str>>() {
                print!("{0: <10}", field);
            }

            println!();
        }

        Ok(())
    }
}
